#include "ToRegExpAlgebraic.h"
#include <registration/AlgoRegistration.hpp>

namespace {

auto ToRegExpAlgebraicLeftRG = registration::AbstractRegister < grammar::convert::ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const grammar::LeftRG < > & > ( grammar::convert::ToRegExpAlgebraic::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression using regular equations.\n\
\n\
@param grammar Grammar to convert\n\
@return regexp describing language generated by the @p grammar" );

auto ToRegExpAlgebraicRightRG = registration::AbstractRegister < grammar::convert::ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const grammar::RightRG < > & > ( grammar::convert::ToRegExpAlgebraic::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression using regular equations.\n\
\n\
@param grammar Grammar to convert\n\
@return regexp describing language generated by the @p grammar" );

} /* namespace */
