// Copyright (c) 2017 Czech Technical University in Prague | Faculty of Information Technology. All rights reserved.

#include "Node.hpp"
#include <registration/ValuePrinterRegistration.hpp>

namespace node {

// ---------------------------------------------------------------------------------------------------------------------

Node::Node() : m_id(-1) {

}

Node::Node(int id) : m_id(id) {

}

// ---------------------------------------------------------------------------------------------------------------------

std::string Node::name() const {
  return "Node";
}

// ---------------------------------------------------------------------------------------------------------------------

void Node::operator>>(std::ostream &ostream) const {
  ostream << "(" << name() << "(id=" << m_id << "))";

}

Node::operator std::string() const {
  std::stringstream ss;
  ss << "(" << name() << "(id=" << m_id << "))";
  return std::move(ss).str();
}

// ---------------------------------------------------------------------------------------------------------------------

int Node::getId() const {
  return m_id;
}

// ---------------------------------------------------------------------------------------------------------------------

} // namespace node

// =====================================================================================================================

namespace {

auto valuePrinter = registration::ValuePrinterRegister<node::Node>();

}
// ---------------------------------------------------------------------------------------------------------------------

